/*
 * Copyright 2008 Gustavo Pichorim Boiko <boiko@mandriva.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#include "toptile.h"

#include <QPainter>

TopTile::TopTile(const QPixmap &pix, QWidget *parent)
: QWidget(parent)
{
       int middle = pix.width() / 2;
       int height = pix.height();

       m_leftPix = pix.copy(0,0,middle,height);
       m_tilePix = pix.copy(middle, 0, 1, height);
       m_rightPix = pix.copy(middle, 0, pix.width() - middle, height);
       setMinimumSize(pix.size());
}

TopTile::~TopTile()
{
}

void TopTile::paintEvent(QPaintEvent *e)
{
       QRect r = rect();
       QPainter p(this);

       p.drawTiledPixmap(r, m_tilePix);
       p.drawPixmap(r.topLeft(), m_leftPix);
       QRect r2 = m_rightPix.rect();
       r2.moveTopRight(r.topRight());
       p.drawPixmap(r2.topLeft(), m_rightPix);
}
